unit TV_Data_Class_U1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,  TreeUtils;

type
  TNodeData = class
     sText : string;
  end;

  TForm1 = class(TForm)
    tv_eg1: TTreeView;
    but_Add: TButton;
    but_Remove: TButton;
    ed_Time: TEdit;
    procedure but_AddClick(Sender: TObject);
    procedure but_RemoveClick(Sender: TObject);
    procedure tv_eg1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.but_AddClick(Sender: TObject);
var
   sText : string;
begin
      {If nothing is selected}
   if(  tv_eg1.Selected = nil  ) then
   begin
         {Does a root node already exist?}
      if(  tv_eg1.Items.Count = 0  ) then
      begin
            {Add the root node}
         with tv_eg1.Items.AddFirst(  nil,  'Root'  ) do
         begin
            Selected := true;

               {Create the data class}
            Data := TNodeData.Create;
               {Set the nodes date time}
            TNodeData(Data).sText := FormatDateTime(  'hh:nn:ss',  now  );
         end;
      end
      else begin
            {There is a root, so user must first select a node}
         MessageBeep(  -1  );
         ShowMessage(  'Select a parent node'  );
         Exit;
      end;
   end
   else begin
         {Get a name for the new node}
      InputQuery(  'New Node',  'Caption ?',  sText  );

         {Add the node as a child of the selected node}
      with tv_eg1.Items.AddChild(  tv_eg1.Selected,  sText  ) do
      begin
            {Create the data class}
         Data := TNodeData.Create;
            {Set the nodes date time}
         TNodeData(Data).sText := FormatDateTime(  'hh:nn:ss',  now  );

         MakeVisible;
      end;
   end;
end;



procedure TForm1.but_RemoveClick(Sender: TObject);
begin
      {Make sure somthing is selected, before trying to
        delete it}
   if(  tv_eg1.Selected = nil  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Nothing selected'  );
      Exit;
   end;

      {Dont allow user to delete the root node}
   if(  tv_eg1.Selected.Level = 0  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Cant delete the root node'  );
      Exit;
   end;

      {Free the class}
   if(  tv_eg1.Selected.Data <> nil  ) then
      TNodeData(tv_eg1.Selected.Data).Free;

      {Delete the node}
   tv_eg1.Selected.Delete;
end;



procedure TForm1.tv_eg1Click(Sender: TObject);
begin
   ed_Time.Text := '';

   if(  tv_eg1.Selected = nil  ) then
      Exit;

   if(  tv_eg1.Selected.Data = nil  ) then
      Exit;

   ed_Time.Text := TNodeData(tv_eg1.Selected.Data).sText;
end;



procedure FreeAll_callback(  Node : TTreeNode;  pData : pointer  );
begin
   if(  Node.Data <> nil  ) then
   begin
         {Free the memory used by the node}
      TNodeData(Node.Data).Free;
      Node.Data := nil;
   end;
end;



procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
      {If there are no nodes, exit}
   if(  tv_eg1.Items.Count <= 0  ) then
      Exit;

      {Call FreeAll_callback once for every node in the tree}
   EnumNodes(  tv_eg1.Items[ 0 ],
               FreeAll_callback,
               nil,
               false
             );
end;

end.
