unit TV_Duplicates_U1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

const
   IMG_NODE_ROOT = 0;
   IMG_NODE_CLOSED = 1;
   IMG_NODE_OPEN = 2;


type
  TForm1 = class(TForm)
    tv_eg1: TTreeView;
    but_Add: TButton;
    but_Remove: TButton;
    ImageList1: TImageList;
    procedure but_AddClick(Sender: TObject);
    procedure but_RemoveClick(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


function IsDuplicateName(  Node : TTreeNode;
                           sNewName : string;
                           bInclusive : boolean
                         ) : boolean;
var
   TestNode : TTreeNode;
begin
   if(  Node = nil  ) then
   begin
      Result := false;
      Exit;
   end;

      {Include this Node?}
   if(  bInclusive  ) then
      if(   CompareText(  Node.Text,  sNewName  ) = 0   ) then
      begin
         Result := true;
         Exit;
      end;


      {Test all previous siblings}
   TestNode := Node;
   repeat
         {Get next}
      TestNode := TestNode.GetPrevSibling;

      if(  TestNode <> nil  ) then
            {Is this a duplicate}
         if(   CompareText(  TestNode.Text,  sNewName  ) = 0   ) then
         begin
            Result := true;
            Exit;
         end;
   until (TestNode = nil);


      {Test all next siblings}
   TestNode := Node;
   repeat
         {Get next}
      TestNode := TestNode.GetNextSibling;

      if(  TestNode <> nil  ) then
            {Is this a duplicate}
         if(   CompareText(  TestNode.Text,  sNewName  ) = 0   ) then
         begin
            Result := true;
            Exit;
         end;
   until (TestNode = nil);

   Result := false;
end;



procedure TForm1.but_AddClick(Sender: TObject);
var
   sText : string;
begin
      {If nothing is selected}
   if(  tv_eg1.Selected = nil  ) then
   begin
         {Does a root node already exist?}
      if(  tv_eg1.Items.Count = 0  ) then
      begin
            {Add the root node}
         with tv_eg1.Items.AddFirst(  nil,  'Root'  ) do
         begin
            Selected := true;

               {Set the roots image index}
            ImageIndex := IMG_NODE_ROOT;
               {Set the roots selected index. The same image is uses
                  as for the ImageIndex}
            SelectedIndex := IMG_NODE_ROOT;
         end;
      end
      else begin
            {There is a root, so user must first select a node}
         MessageBeep(  -1  );
         ShowMessage(  'Select a parent node'  );
         Exit;
      end;
   end
   else begin
         {Get a name for the new node}
      InputQuery(  'New Node',  'Caption ?',  sText  );

         {Check if this name is already in use}
      if(   IsDuplicateName(  tv_eg1.Selected.GetFirstChild,
                              sText,
                              true
                            )
         ) then
      begin
         MessageBeep(  -1  );
         ShowMessage(  'A node with this name already exists'  );
         Exit;
      end;


         {Add the node as a child of the selected node}
      with tv_eg1.Items.AddChildFirst(  tv_eg1.Selected,  sText  ) do
      begin
            {Set the image used when the node is not selected}
         ImageIndex := IMG_NODE_CLOSED;
            {Image used when the node is selected}
         SelectedIndex := IMG_NODE_OPEN;

         MakeVisible;
      end;
   end;
end;



procedure TForm1.but_RemoveClick(Sender: TObject);
begin
      {Make sure somthing is selected, before trying to
        delete it}
   if(  tv_eg1.Selected = nil  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Nothing selected'  );
      Exit;
   end;

      {Dont allow user to delete the root node}
   if(  tv_eg1.Selected.Level = 0  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Cant delete the root node'  );
      Exit;
   end;


      {Delete the node}
   tv_eg1.Selected.Delete;
end;

end.
