unit TV_Pre_PostOrder_U1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  EnumNodesProc = procedure(  Node : TTreeNode;  pData : pointer  );

  TForm1 = class(TForm)
    tv_eg1: TTreeView;
    but_Add: TButton;
    but_Remove: TButton;
    mem_Order: TMemo;
    but_Transverse: TButton;
    cbox_PreOrder: TCheckBox;
    procedure but_AddClick(Sender: TObject);
    procedure but_RemoveClick(Sender: TObject);
    procedure but_TransverseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.but_AddClick(Sender: TObject);
var
   sText : string;
begin
      {If nothing is selected}
   if(  tv_eg1.Selected = nil  ) then
   begin
         {Does a root node already exist?}
      if(  tv_eg1.Items.Count = 0  ) then
      begin
            {Add the root node}
         with tv_eg1.Items.AddFirst(  nil,  'Root'  ) do
         begin
            Selected := true;
         end;
      end
      else begin
            {There is a root, so user must first select a node}
         MessageBeep(  -1  );
         ShowMessage(  'Select a parent node'  );
         Exit;
      end;
   end
   else begin
         {Get a name for the new node}
      InputQuery(  'New Node',  'Caption ?',  sText  );

         {Add the node as a child of the selected node}
      with tv_eg1.Items.AddChild(  tv_eg1.Selected,  sText  ) do
      begin
         MakeVisible;
      end;
   end;
end;



procedure TForm1.but_RemoveClick(Sender: TObject);
begin
      {Make sure somthing is selected, before trying to
        delete it}
   if(  tv_eg1.Selected = nil  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Nothing selected'  );
      Exit;
   end;

      {Dont allow user to delete the root node}
   if(  tv_eg1.Selected.Level = 0  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Cant delete the root node'  );
      Exit;
   end;


      {Delete the node}
   tv_eg1.Selected.Delete;
end;



procedure EnumNodes(  Node : TTreeNode;
                      Enum : EnumNodesProc;
                      pData : pointer;
                      bPre : boolean
                    );
begin
   //////////////////////////////////////////////////////////////////////
   //  Enter Function              <------+  <---+
   //                                     |      |
   //    Process this node  (if Pre)      |      |
   //                                     |      |
   //    If this node has children        |      |
   //       Call Enum with  first child---+      |
   //                                            |
   //    If this node has siblings               |
   //       Call Enum with  next sibling---------+
   //
   //
   //    Process this node  (if not Pre)
   //////////////////////////////////////////////////////////////////////
   // EnumNodesProc = procedure(  Node : TTreeNode;  pData : pointer  );
   ///////////////////////////////////////////////////////////////////////

   if(  Node = nil  ) then
      Exit;

      {Preorder}
   if(  bPre  ) then
      Enum(  Node,  pData  );


   if(  Node.GetFirstChild <> nil  ) then
      EnumNodes(  Node.GetFirstChild,  Enum,  pData,  bPre  );

   if(  Node.GetNextSibling <> nil  ) then
      EnumNodes(  Node.GetNextSibling,  Enum,  pData,  bPre  );

      {Postorder}
   if(  not bPre  ) then
      Enum(  Node,  pData  );
end;



procedure Enum(  Node : TTreeNode;  pData : pointer  );
begin
   Form1.mem_Order.Lines.Add(  Node.Text  );
end;



procedure TForm1.but_TransverseClick(Sender: TObject);
begin
   mem_Order.Clear;

   if(  tv_eg1.Items.Count = 0  ) then
      Exit;


   EnumNodes(  tv_eg1.Items[ 0 ],
               @Enum,
               nil,
               cbox_PreOrder.Checked
             );  
end;

end.
