unit TV_Text_Edit_U1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    tv_eg1: TTreeView;
    but_Add: TButton;
    but_Remove: TButton;
    mem_History: TMemo;
    procedure but_AddClick(Sender: TObject);
    procedure but_RemoveClick(Sender: TObject);
    procedure tv_eg1Editing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure tv_eg1Edited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure tv_eg1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.but_AddClick(Sender: TObject);
var
   sText : string;
begin
      {If nothing is selected}
   if(  tv_eg1.Selected = nil  ) then
   begin
         {Does a root node already exist?}
      if(  tv_eg1.Items.Count = 0  ) then
      begin
            {Add the root node}
         with tv_eg1.Items.AddFirst(  nil,  'Root'  ) do
         begin
            Selected := true;
         end;
      end
      else begin
            {There is a root, so user must first select a node}
         MessageBeep(  -1  );
         ShowMessage(  'Select a parent node'  );
         Exit;
      end;
   end
   else begin
         {Get a name for the new node}
      InputQuery(  'New Node',  'Caption ?',  sText  );

         {Add the node as a child of the selected node}
      with tv_eg1.Items.AddChild(  tv_eg1.Selected,  sText  ) do
      begin
         MakeVisible;
      end;
   end;
end;



procedure TForm1.but_RemoveClick(Sender: TObject);
begin
      {Make sure somthing is selected, before trying to
        delete it}
   if(  tv_eg1.Selected = nil  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Nothing selected'  );
      Exit;
   end;

      {Dont allow user to delete the root node}
   if(  tv_eg1.Selected.Level = 0  ) then
   begin
      MessageBeep(  -1  );
      ShowMessage(  'Cant delete the root node'  );
      Exit;
   end;


      {Delete the node}
   tv_eg1.Selected.Delete;
end;



procedure TForm1.tv_eg1Editing(Sender: TObject; Node: TTreeNode;  var AllowEdit: Boolean);
begin
      {All but root may be edited}
   AllowEdit := (Node <> tv_eg1.Items[ 0 ]);
end;



procedure TForm1.tv_eg1Edited(Sender: TObject; Node: TTreeNode;  var S: String);
begin
   mem_History.Lines.Insert(  0,  Node.Text + ' --> renamed --> ' + S  );
end;



procedure TForm1.tv_eg1KeyUp(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
   case Key of
      VK_F2 :
      begin
         if(  tv_eg1.Selected <> nil  ) then
            tv_eg1.Selected.EditText;
      end;

      VK_DELETE :
      begin
         if(  tv_eg1.Selected <> nil  ) then
            if(  not tv_eg1.IsEditing  ) then
               but_Remove.Click;
      end;
   end;
end;

end.
