unit TreeUtils;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;


type
   EnumNodesProc = procedure(  Node : TTreeNode;  pData : pointer  );


procedure EnumNodes(  Node : TTreeNode;
                      Enum : EnumNodesProc;
                      pData : pointer;
                      bPre : boolean
                    );

implementation


procedure EnumNodes(  Node : TTreeNode;
                      Enum : EnumNodesProc;
                      pData : pointer;
                      bPre : boolean
                    );
begin
   //////////////////////////////////////////////////////////////////////
   //  Enter Function              <------+  <---+
   //                                     |      |
   //    Process this node  (if Pre)      |      |
   //                                     |      |
   //    If this node has children        |      |
   //       Call Enum with  first child---+      |
   //                                            |
   //    If this node has siblings               |
   //       Call Enum with  next sibling---------+      //      //
   //    Process this node  (if not Pre)
   //////////////////////////////////////////////////////////////////////
   // EnumNodesProc = procedure(  Node : TTreeNode;  pData : pointer  );
   ///////////////////////////////////////////////////////////////////////

   if(  Node = nil  ) then
      Exit;

      {Preordal}
   if(  bPre  ) then
      Enum(  Node,  pData  );

   if(  Node.GetFirstChild <> nil  ) then
      EnumNodes(  Node.GetFirstChild,  Enum,  pData,  bPre  );

   if(  Node.GetNextSibling <> nil  ) then
      EnumNodes(  Node.GetNextSibling,  Enum,  pData,  bPre  );

      {Postordal}
   if(  not bPre  ) then
      Enum(  Node,  pData  );
end;

end.
